#ifndef STRING_H
#define STRING_H

#include <iostream.h>
#include <string.h>

#ifndef NO_OBJECTSTORE
#include <ostore/ostore.hh>
#endif

#ifdef macintosh
#include ":Generic:src:GenericList.h"
#else
#include "GenericList.h"
#endif

class srep {
  public:
    char* s;            // pointer to data
    int n;		// reference count
    int len;		// string length  MJW
    int size;		// physical size  MJW
    srep() { n = 1; }

#ifndef NO_OBJECTSTORE
    static os_typespec  *get_os_typespec() {
	static os_typespec *srep_type = new os_typespec("srep");
	return srep_type;
    }
#endif
};

class String  {
    srep *p;
    
  public:
    String(const char *);	// String x = "abc"
    String();			// String x
    String(const String &);	// String x = String ...
    
    String& operator=(const char *);
    String& operator=(const String &);
    String& operator+=(const String&);

    ~String();
    char& operator[](int i);
    const char& operator[](int i) const;

#ifndef NO_OBJECTSTORE
    static os_typespec  *get_os_typespec() {
	static os_typespec *String_type = 
	  new os_typespec("String");
	return String_type;
    };
#endif

    const char* StringToChar()	{ return p->s; }
    int StringLength()		{ return p->len; }

friend ostream& operator<<(ostream&, const String&);
friend istream& operator>>(istream&, String&);
friend String operator+(String&, String&);
friend String operator+(String&, const char*);
friend String operator+(const char*, String&);

friend int operator==(const String &x, const char *s)
    { return strcmp(x.p->s, s) == 0; }
friend int operator==(const String &x, const String &y)
    { return strcmp(x.p->s, y.p->s) == 0; }   
friend int operator!=(const String &x, const char *s)
    { return strcmp(x.p->s, s) != 0; }
friend int operator!=(const String &x, const String &y)
    { return strcmp(x.p->s, y.p->s) != 0; }
};  
#endif
