#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>

/* #   define  NULL    0 */
#ifdef _AIX
#include <sys/select.h>
#endif

static	fd_set	readfds;
static	fd_set	writefds;
static	fd_set	exceptfds;

/* call select on 1 fd to see if it is ready to read,
   with a timeout in microseconds, or
   block if timeout < 0
*/

int 	call_select (fd, timeout)
     int    fd;
     int    timeout;
{  
  struct timeval timer;
  struct timeval *timer_ptr;
  int	    	read_ok;
  
  FD_ZERO (&readfds);
  FD_ZERO (&exceptfds);
  
  FD_SET(fd, &exceptfds);
  FD_SET(fd, &readfds);
  if (timeout < 0)
    timer_ptr = NULL;
  else
    {
      timer.tv_sec = 0;
      timer.tv_usec = timeout;
      timer_ptr = &timer;
    }
  read_ok = select(fd + 1, &readfds, NULL, &exceptfds, timer_ptr);

  return read_ok;
}
