// $Author: jmartin $
// $Date: 1997-12-05 01:57:18 $
// $Source: /root/cvs/Rigi/rigiedit/UT/src/sexps.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef SEXP_H
#define SEXP_H

// The sexp routines handle parsing and writing of general LISP sexps.

// Parsing: done through a callback function which gives the literal,
// its depth, its index at that depth, and its index at depth 0.
// (This is sufficient for the NetworkObject syntax).
// For example, parsing "(()(zeb))" would produce <"zeb",1,0,1>.

// Writing: very simpleminded and hacky.

typedef void (*SexpFunc)(char*atom,int d,int i,int t);

void parse_sexp( const char *, void (*)(char*lit,int depth,int index,int t) );
int parse_sexps( FILE *f, void (*)(char*,int,int,int) );


// This one is experimental and unused. It parses only the NetworkObject
// subgrammar of sexps.

void parse_object( const char *p );

void write_sexp( const char *s );
void reset_sexp();
void close_sexp();

char *get_sexp();

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.4  1995/02/15  19:16:22  mwhitney
//   extra parm for parse callback function pointer
//
//   Revision 1.3  1994/10/21  21:45:54  mwhitney
//   more protos
//
//   Revision 1.2  1994/08/19  17:05:38  mwhitney
//   minor
//
//   Revision 1.1  1994/08/17  20:48:09  mwhitney
//   Initial revision
//
//
