#include "mbus-interface.H"

extern "C" {
int MBLogLevel = 0;
int MBtransmit_Cstring(t_mb_connection conn, char* str);
int call_select(int fd, int timeout);
}

t_mb_connection T_MB_CONNECTION;

int CONN_FD = 0;

extern String* ERROR_BUFFER;

#define MAX_COMMAND_LENGTH 10000
#define MAX_DOMAIN_LENGTH  10000
#define MAX_MESSAGE_SIZE   10000


// HACK! These symbols repeated elsewhere! MJW

static String* sDot = new String(".");
static String* sQuote = new String("\"");
static String* sDotQuote = new String(".\"");
static String* sQuoteDot = new String("\".");
static String* sSpaceRBracket = new String(" )");
static String* sSpace = new String(" ");


void tml_lost_connection(t_mb_connection conn) 
        { 
	    cerr << "hello" << endl << flush;
return; };

void
TML_mbus_init() {
    mb_lost_connection_function = tml_lost_connection;
}

void MB_connect(String* host, int port) 
  { if ((T_MB_CONNECTION = MBConnect((char*)host->StringToChar(), port)) ==
        (t_mb_connection)NULL) 
       TMB_ERROR->setError(TMB_CannotConnect);
    else
       CONN_FD = MBconnection_fd (T_MB_CONNECTION);
  };


void MB_close()
  { static char close_command [] = "(close)";
    static int len = strlen(close_command);
    if (MBtransmit_buffer(T_MB_CONNECTION, close_command, len) != len)
       TMB_ERROR->setError(TMB_CannotDisconnect);
  };

void MB_clear()
  { static char clear_command [] = "(clear)";
    static int len = strlen(clear_command);
    if (MBtransmit_buffer(T_MB_CONNECTION, clear_command, len) != len)
       TMB_ERROR->setError(TMB_CannotClear);
  };


void MB_id(String* userId)
  { char id_command[MAX_COMMAND_LENGTH];
    int len;
    sprintf(id_command, "id \"%s\"", userId->StringToChar());
    len = strlen(id_command);

  if (MBtransmit_buffer(T_MB_CONNECTION, id_command, len) != len)
       TMB_ERROR->setError(TMB_CannotRegisterId);
  };


void MB_accept(String* domains)
  { String* accept_command = new String("( accept \"my-tag\" ");
    int  len;
    *accept_command += *domains;
    *accept_command += *sSpaceRBracket;
    len = accept_command->StringLength();

    if (MBtransmit_buffer(T_MB_CONNECTION, 
             (char*)accept_command->StringToChar(), len) != len)
       TMB_ERROR->setError(TMB_CannotAccept);
    delete accept_command; //MJW
  };


// MJW  Check for balanced parentheses
static int check( register const char *s, register int len )
{
    register int i=0;
    if (*s && len>0) do {
	if (*s=='(') i++; else if (*s==')') i--;
        if (i<0) return 1;
    } while (*++s && --len);
    return i;
}

void MB_sendMessage(String* dataString, String* domainString) 
{
    String* a_message = new String("( \"my-tag\" ");
    int  len;
    *a_message += *domainString;
    *a_message += *sSpace;
    *a_message += *dataString;
    *a_message += *sSpaceRBracket;
    len = a_message->StringLength();
    //if (check(a_message->StringToChar(),len))
        //fprintf(stderr,"ERROR: bad mbus message!\n");

    if (MBtransmit_buffer(T_MB_CONNECTION, 
             (char*)a_message->StringToChar(), len) != len)
       TMB_ERROR->setError(TMB_CannotSend);
    delete a_message; //MJW
}



String* MB_makeDomainString(String* context, String* userId, String* tool)
{ String* domainString = new String();
  if (context->StringLength() == 0)
     { if (tool->StringLength() == 0)
          { if (userId->StringLength() == 0)
               *domainString = *sQuoteDot + *sQuote;
            else
               { *domainString = *sQuoteDot + *userId;
                 *domainString += *sQuote;
               }
          }
        else
          { if (userId->StringLength() == 0)
               { *domainString = *sQuoteDot + *tool;
                 *domainString += *sDotQuote;
               }
            else
               { *domainString = *sQuoteDot + *tool;
                 *domainString += *sDot;
                 *domainString += *userId;
                 *domainString += *sDotQuote;
               }
          };
     }
   else
     { if (tool->StringLength() == 0)
          { if (userId->StringLength() == 0)
               { *domainString = *sQuote + *context;
                 *domainString += *sDotQuote;
               }
            else
               { *domainString = *sQuote + *context;
                 *domainString += *sDot;
                 *domainString += *tool;
                 *domainString += *sDotQuote;
               }
          }
        else
          { if (userId->StringLength() == 0)
               { *domainString = *sQuote + *context;
                 *domainString += *sDot;
                 *domainString += *userId;
                 *domainString += *sQuote;
               }
            else
               { *domainString = *sQuote + *context;
                 *domainString += *sDot;
                 *domainString += *tool;
                 *domainString += *sDot;
                 *domainString += *userId;
                 *domainString += *sQuote;
               }
          }
     }
  return domainString;
};

String* MB_makeDomainSpecString (String* context, String* userId, String* tool)
{ String* domainSpecString = new String();

  if (context->StringLength() == 0)
     { if (tool->StringLength() == 0)
          { if (userId->StringLength() == 0)
               { *domainSpecString = *sQuoteDot + *sQuote;
               }
            else
               { *domainSpecString = *sQuote + *userId;
                 *domainSpecString += *sQuote;
               }
          }
        else
          { if (userId->StringLength() == 0)
               { *domainSpecString = *sQuote + *tool;
                 *domainSpecString += *sQuote;
               }
            else
               { *domainSpecString = *sQuote + *tool;
                 *domainSpecString += *sDot;
                 *domainSpecString += *userId;
                 *domainSpecString += *sQuote;
               }
          };
     }
   else
     { if (tool->StringLength() == 0)
          { if (userId->StringLength() == 0)
               { *domainSpecString = *sQuote + *context;
                 *domainSpecString += *sQuote;
               }
            else
               { *domainSpecString = *sQuote + *context;
                 *domainSpecString += *sDot;
                 *domainSpecString += *userId;
                 *domainSpecString += *sQuote;
               }
          }
        else
          { if (userId->StringLength() == 0)
               { *domainSpecString = *sQuote + *context;
                 *domainSpecString += *sDot;
                 *domainSpecString += *tool;
                 *domainSpecString += *sQuote;
               }
            else
               { *domainSpecString = *sQuote + *context;
                 *domainSpecString += *sDot;
                 *domainSpecString += *tool;
                 *domainSpecString += *sDot;
                 *domainSpecString += *userId;
                 *domainSpecString += *sQuote;
               }
          }
     }
  return domainSpecString;
};

t_sexp MB_waitForMessage()
  { t_sexp    message;
    while (1)
      { message = MBNextMessage(T_MB_CONNECTION);
        if (message)
	    break;
        call_select (CONN_FD, -1);
      }
    return message;
};

t_sexp MB_getNewMessage()
  { return MBNextMessage(T_MB_CONNECTION); };
