// $Author: jmcdanie $
// $Date: 1995-11-24 18:55:23 $
// $Source: /root/cvs/Rigi/rigiedit/adt/array.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef ARRAYOBIDH
#define ARRAYOBIDH

#ifndef COLLECTIONH
#include "collection.h"
#endif

class Array;
typedef Array* ArrayPtr;
typedef void (*ArrFreeFunc)(ObjectPtr);

class Array : private Collection {

	ObjectPtr*	series;
	unsigned int   	totalsize;
	ArrFreeFunc FreeFunc;
	void		AllocSizeErr();
	void		IndexRangeErr() const;

	public:

	// Routines to initialize and destroy the class.
	Array(unsigned int size = CLTN_DEFAULT_CAPACITY);
	Array(const Array&);
	~Array();

	// Functions that are Required to Use this Class as an RigiObject
	virtual	int Printout(int) const;
	virtual unsigned int Hash() const;
	virtual RigiBool isEqual(void* a) const;
	virtual void* Create_class();
	virtual void* Duplicate_class();
	virtual void Delete_class(ObjectPtr) {}

	// Routines that are required by a Collection class and derived classes
	// of Collections
	virtual RigiBool		IsNil(const CltnPos& a)
		{return ((RigiBool)(series[a.index] == NIL));}

	virtual ObjectPtr doNext(CltnPos& a) const;
	virtual ObjectPtr doFirst(CltnPos& a);
	virtual ObjectPtr doPrev(CltnPos& a);
	virtual ObjectPtr doLast(CltnPos& a);

	virtual ObjectPtr Next(CltnPos& a)
		{return series[a.index++];}
	virtual ObjectPtr Prev(CltnPos& a)
		{return series[a.index--];}
	virtual RigiBool NotEnd(const CltnPos& a)
		{return ((RigiBool)((unsigned)a.index < totalsize));}
	virtual void SetElem(const CltnPos& a,ObjectPtr b)
		{series[a.index] = b;}
	virtual ObjectPtr Elem(const CltnPos& a)
		{return series[a.index];}
	virtual CltnPos	SetPos(CltnPos& a,int i)
		{a.index = i; return a;}
	virtual void reSize(unsigned int);
	virtual unsigned int Size() const
		{return totalsize;}
	virtual unsigned int Capacity() const
		{return totalsize;}

	// Routines specific to this class
	void		Add(int,ObjectPtr);
	ObjectPtr	Find(ObjectPtr);
	ObjectPtr	FindAddress(ObjectPtr);
	int     	FindIndex(ObjectPtr);
	ObjectPtr	Remove(int);
	void		Empty();
	void		SetFreeFunc(ArrFreeFunc f) { FreeFunc = f; }
	int		Occurences(ObjectPtr);
	void 		operator=(const Array&);
	RigiBool	operator!=(const Array& a) const
		{return((RigiBool)(!(*this==a))); }
	RigiBool 	operator==(const Array&) const;
	ObjectPtr&	operator[](int i) const
		{if ((unsigned int)i >= totalsize) IndexRangeErr();
		return series[i];}
	ObjectPtr 	At(int i) const;
	void 		Sort();
	
};

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.3  1995/06/12  22:23:57  jmcdanie
//   PC port
//
//   Revision 1.2  1994/06/30  17:40:41  bcorrie
//   Fixed up RCS header stuff
//
//

