// $Author: jmcdanie $
// $Date: 1995-06-12 22:06:10 $
// $Source: /root/cvs/Rigi/rigiedit/adt/charlist.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#define FDEBUG
#ifndef DEBUGTYPEH
#include "ccdebug.h"
#endif

#ifndef CHARLISTH
#include "charlist.h"
#endif

static CharType char_find;

CharList::CharList(unsigned int size) : HashTbl (size) {
//	MsgDebug("Created Charlist.",CharList::CharList);
}

CharList::~CharList() {
}

CharTypePtr CharList::Create(char*  str) {
    
    CharTypePtr tmp = new CharType(str);
    ObjectPtr  tmp2;
    
    if((tmp2 = HashTbl::Add((ObjectPtr) tmp)) == NULL) {
	return tmp;
    }
    else {
	delete tmp;
	return((CharTypePtr)tmp2); 
    }

}

RigiBool CharList::Add(CharTypePtr ob) {
	ObjectPtr tmp;
	if(ob == NULL) {
		return(RigiFalse);
	}
	
	if((tmp = HashTbl::Add((ObjectPtr) ob)) == NULL) {
		return RigiTrue;   // successfull add.
	}
	else {
		return RigiFalse;   // already was present.
	}
	
}

RigiBool CharList::Add(CharType& ob) {
	ObjectPtr tmp;
	
	if((tmp = HashTbl::Add((ObjectPtr) &ob)) == NULL) {
		return RigiTrue;   // successfull add.
	}
	else {
		return RigiFalse;   // already was present.
	}
	
}

RigiBool CharList::Includes(char* str) {
 	CharType ob(str);
	if(HashTbl::Find((ObjectPtr) &ob) == NULL) {
		return(RigiFalse);
	}
 	else {
		return(RigiTrue);
	}

}

char* CharList::Remove(char* str) {
 	CharType ob(str);
	CharTypePtr tmp;

	tmp = (CharTypePtr) HashTbl::Remove((ObjectPtr) &ob);
	if(tmp != NULL) {
		return(tmp->string()); 
	}
	else {
		return NULL;
	}
	
}

char* CharList::Remove(CharTypePtr str) {
	CharTypePtr tmp;

	tmp = (CharTypePtr) HashTbl::Remove((ObjectPtr) str);
	if(tmp != NULL) {
		return(tmp->string()); 
	}
	else {
		return NULL;
	}
}

CharType* CharList::Find(char* value) {
    	char_find.Assign(value);
	ObjectPtr tmp = HashTbl::Find((ObjectPtr) &char_find);
	if(tmp == NULL) {
	    ValueDebug("Did not FIND ",value,CharList::Find);
	}
	return((CharType*) tmp);
}

RigiBool CharList::operator==(const CharList& a)const {
	return ((RigiBool)(HashTbl::operator==(*((HashTblPtr)&a))));
}	

void CharList::operator=(const CharList& a) {
	HashTbl::operator=(*((HashTblPtr)&a));
}  
 
void CharList::operator&(const CharList& a) {
	HashTbl::operator&(*((HashTblPtr)&a));
}	

void CharList::operator|(const CharList& a) {
	HashTbl::operator|(*((HashTblPtr)&a));
}	

void CharList::operator-(const CharList& a) {
	HashTbl::operator-(*((HashTblPtr)&a));
}	









// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.1  1994/06/30  20:09:05  bcorrie
//   Initial revision
//
//

