// $Author: jmartin $
// $Date: 2002-11-10 22:16:58 $
// $Source: /root/cvs/Rigi/rigiedit/adt/chartype.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef CHARTYPEH
#define CHARTYPEH

#ifndef STREAMH
#include <iostream>
#endif
#ifndef OBJECTH
#include "object.h"
#endif

class CharType;
typedef CharType* CharTypePtr;

class CharType : public RigiObject {
	char* name;
    public:
	CharType();
	CharType(char*);
	CharType(char*,int);
	CharType(double);
	CharType(CharTypePtr);
	CharType(CharType&);
	~CharType();
	void Assign(const char*);
	void Assign(char*,int);
	void SetString(char *a) { if (name!=NULL) delete[] name; name = a; }

	char *string() const { return name; }
	double Double();
	int Length() {if(name != NULL) return strlen(name); else return 0;}
	void Append(const char*);

	RigiBool operator==(const CharType& a) const;
	void operator=(const CharType& a);

   // Routines that are required by a Object class and derived classes of 
   // Objects
	virtual int Printout(int) const;
	virtual unsigned int Hash() const;                 
	virtual RigiBool isEqual(void* a) const;
	virtual void* Duplicate();
	virtual void* Create() { return ((void*) new CharType); }
	virtual void  Delete_type(ObjectPtr);

};

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
// Revision 1.4  2000/02/05 02:21:53  jmartin
// fixed some ANSI C++ non compliant pieces of code
//
// Revision 1.3  1995/06/12 22:24:01  jmcdanie
// PC port
//
//   Revision 1.2  1994/06/30  17:40:51  bcorrie
//   Fixed up RCS header stuff
//
//

