// $Author: jmcdanie $
// $Date: 1995-06-12 22:24:02 $
// $Source: /root/cvs/Rigi/rigiedit/adt/hash.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef HASHTBLH
#define HASHTBLH

#ifndef ARRAYOBIDH
#include "array.h"
#endif

class HashTbl;
typedef HashTbl* HashTblPtr ;

class HashTbl : private RigiObject {
	unsigned int count;			// number of objects in set 
	unsigned int nbits;			// log base 2 of contents.capacity() 
protected:
	unsigned int mask;			// contents.capacity()-1 
	Array table;				// array of set objects 
	unsigned int hashCapacity(unsigned int);	// compute set allocation size 
	int h(unsigned int long) const;	// convert hashtbl key into contents index 
	ObjectPtr findObjectWithKey(ObjectPtr);
	int findIndexOf(ObjectPtr) const;
public:
	HashTbl(unsigned int);
    HashTbl(CollectionPtr);
	HashTbl();
	HashTbl(const HashTbl&);
	~HashTbl() {}
   // Routines that are required by Objects and derived classes of
   // objects.

 	virtual	int Printout(int) const;
	virtual unsigned int Hash() const;               
	virtual RigiBool isEqual(void* a) const;
	virtual void* Create_class() { return NULL; }
	virtual void* Duplicate_class() {return NULL;}
	virtual void Delete_class(ObjectPtr) { }

   // Routines that are required by the Collection class and derived classes
   // of Collections. 
	virtual ObjectPtr doNext(CltnPos&) const;
    virtual ObjectPtr doFirst(CltnPos&) const;
   	virtual void SetElem(const CltnPos&,ObjectPtr);
	virtual void reSize(unsigned int);
	virtual unsigned int Size() const;
	virtual unsigned int Capacity() const;
	virtual unsigned int NumElements() const;


   // Routines that are used just by a HashTbl class
   	void AddAll(const Array&);
	ObjectPtr Add(ObjectPtr);
	ObjectPtr Remove(ObjectPtr);
	ObjectPtr Find(ObjectPtr) const;
	void Empty() {table.Empty(); count = 0;}
	RigiBool Includes(ObjectPtr) const;
	RigiBool operator==(const HashTbl&) const;
	void operator-(const HashTbl&);
	void operator^(const HashTbl&);
	void operator|(const HashTbl&);
	void operator&(const HashTbl&);
	void operator=(const HashTbl&);
	unsigned int occurrencesOf(ObjectPtr) const;
	Array& Table() {return table;}
	
};

inline unsigned int HashTbl::Capacity() const { 
	return table.Capacity()/CLTN_EXPANSION_FACTOR; 
}


#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:40:55  bcorrie
//   Fixed up RCS header stuff
//
//

