// $Author: jmartin $
// $Date: 2002-11-10 22:16:58 $
// $Source: /root/cvs/Rigi/rigiedit/adt/timer.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

/*
 *	
 *	Written by
 *
 *	Bruce Eckel
 *	School of Oceanography; WB-10
 *	University of Washington
 *	Seattle, WA 98195
 *
 *	%W%	%G%
 */

#if !defined (_MSC_VER) && !defined (__EMX__) && !defined(__WIN32__)
#include "timer.h"

#ifndef __linux__
extern "C" int getrusage(int, struct rusage*);
#endif

MarkPointArray::~MarkPointArray() {
	IterDO(*this,MarkPoint*,pt)
		delete pt;
	ODretI
}

void Timer::timer_(float& seconds)
{
  struct rusage use;
  double usertime, systime;

  getrusage(RUSAGE_SELF, &use);

  usertime = (double)use.ru_utime.tv_sec +
    ((double)use.ru_utime.tv_usec)/1.0e6;

  systime = (double)use.ru_stime.tv_sec +
    ((double)use.ru_stime.tv_usec)/1.0e6;

  seconds = (float)(usertime + systime);

  return;
}



/*
 * ++ Timer::Mark(): mark timing information at this point in the program
 *
 *  history:
 *  	27 Apr 88	Bruce Eckel	Creation date
 * 	29 Apr 90	Craig Sinclair  Simplified
 *  detailed:
 */

void Timer::Mark()
{
	float seconds;
	timer_(seconds);
	events.Create(seconds,"Marker ");
}

/*
 * ++ Timer::Mark(): place a marker with a message
 *
 *  history:
 *  	27 Apr 88	Bruce Eckel	Creation date
 * 	29 Apr 90       Craig Sinclair  Simplified
 *  detailed:
 */

void Timer::Mark(char * message)
{
	float seconds;
	timer_(seconds);
	events.Create(seconds,message);
}

/*
 * ++ operator<<(): how to output timing information via streams
 *
 *  history:
 *  	27 Apr 88	Bruce Eckel	Creation date
 * 	29 Apr 90       Craig Sinclair  Simplified
 *
 *  detailed:
 */


ostream& operator<<(ostream & s,MarkPoint & t) {

	s << t.Message() << ": time = ";
	s << t.Seconds() << "\n";
	
	return s;
}

ostream& operator<<(ostream & s,MarkPointArray& array) {

    IterDO(array,MarkPoint*,pt)
	s << "Marker " << DO_pos.index << ": ";
        s << *pt;
    ODretI
    return s;
}

ostream& operator<<(ostream & s, Timer & t) {
	s << t.events;
	return s;
}
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
// Revision 1.3  1999/06/11 14:16:44  jmartin
// *** empty log message ***
//
// Revision 1.2  1999/06/07 17:35:04  jmartin
// changes for compilation under OS/2
//
// Revision 1.1  1994/06/30 20:09:14  bcorrie
// Initial revision
//
//
