// avl.h

#ifndef _avlh
#define _avlh

extern const int INVALID;

typedef int	Avlset;

extern int	SetInfo( Avlset, char *s, int info );

extern int	SetString( Avlset, int info, char *s );

extern Avlset	NewSet();
extern Avlset	NewSet( int );
extern int	PrintSet( Avlset );
extern int	FreeSet( Avlset );
extern int	SetSize( Avlset );

/*
        Description:

        NewSet(i) returns a handle to an empty new set. INVALID
                is returned if cannot get one. If neglected to
                use, the one set is identified by 0.
                Parameter indicates if string or info is key.

        PrintSet() dumps out the current set, with size info.
        FreeSet() frees the current set.

        SetInfo( a,s,i ) resets the info of s to i, and returns
                INVALID if s is new to the set, or else the old info.
                If i is INVALID, no new record is created.

        SetString( a,i,s ) resets the string associated with set a and
                info i, to s, and returns NULL if s is new, or else
                the original string.

        Info must be not -1!
*/
#endif
