//
// File:    cl_activearc.c
// Author:  Brian Corrie
// Date:    January 16, 1991
// Project: Rigi V4.0
//

// $Author: jmartin $
// $Date: 2000-02-05 02:18:28 $
// $Source: /root/cvs/Rigi/rigiedit/cl_activearc.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: cl_activearc.C,v 1.11 2000-02-05 02:18:28 jmartin Exp $";

//------------------------------------------------------------------------

#include <stdio.h>
#ifndef ACTIVEARC_H
#include "cl_activearc.h"
#endif
#ifndef RIGIARC_H
#include "cl_rigiarc.h"
#endif

static int naarcs=0; // MJW for memory debugging
int GetNoAArcs() { return naarcs; }

// Need a bunch of static stuff for the iterator functions
static RigiArc *rigiarc;
static RigiWindow *rigiwin;
static void find( RigiArc *r ) { if (r->GetWindow()==rigiwin) rigiarc=r; }
static void draw( RigiArc *r ) { r->Draw(); }


ActiveArc::ActiveArc() { naarcs++; }

ActiveArc::~ActiveArc()
{
    // Remove all rigiarcs from the activearc's list, and destroy them. This
    // is a bit dangerous, as there may be some stray references lying around,
    // but hopefully they will be cleaned up before the activearc is destroyed.
    // No RigiArcs should remain when its ActiveArc is destroyed.

    RigiArc *ra;
    while ( ra = (RigiArc*)RemoveFirst()) delete ra;
    naarcs--;
}

RigiArc* ActiveArc::FindRigiArc( RigiWindow* rw )
{
    if (!rw) return NULL;
    rigiwin = rw;
    rigiarc = NULL;
    Iterator( (VarArgFunRef)find );
    return rigiarc;
}

void ActiveArc::DrawAll() { Iterator((VarArgFunRef)draw); }

