//
// File:    cl_activenode.c
// Author:  Brian Corrie
// Date:    January 16, 1991
// Project: Rigi V4.0
//

// $Author: mwhitney $
// $Date: 1996-01-04 18:58:10 $
// $Source: /root/cvs/Rigi/rigiedit/cl_activenode.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: cl_activenode.C,v 1.10 1996-01-04 18:58:10 mwhitney Exp $";

//------------------------------------------------------------------------

#ifndef ACTIVENODE_H
#include "cl_activenode.h"
#endif

static int nanodes=0;

const int ACTIVE = 0;
const int NORMAL = 1;

ActiveNode::ActiveNode()
{
    nanodes++;
    state = NORMAL;
}

ActiveNode::ActiveNode( int s )
{
    nanodes++;
    state = s;
}

ActiveNode::~ActiveNode()
{
    // Warning: This could be dangerous, deleting the RigiNodes in destructor
    // as they are not created as a result of putting them in the list. It is
    // therefore possible to have a RigiNode in this list (although there should
    // not be any) that is not deleted from all other lists. See also
    // WindowDeleteActiveNode() to see how the other lists are cleaned up. If
    // this class was a subclass of node, then I don't beleive this would be an
    // issue. Especially if RigiNodes were only created as a result of putting
    // then in the ActiveNodes list.

    nanodes--;
    for ( RigiNode* rnp = nl.First(); rnp; rnp = nl.First() )
    {
        nl.Remove( rnp ) ;
        delete rnp ;
    }
}

int GetNoANodes() { return nanodes; }

RigiNode* ActiveNode::FindRigiNode( RigiWindow* win )
{
    if (win==NULL) return NULL;
    for ( RigiNode* rnp = nl.First(); rnp; rnp = nl.Next() )
        if (rnp->GetWindow() == win) return rnp;
    return NULL;
}
