//
// File:    cl_activenode.h
// Author:  Brian Corrie
// Date:    January 16,1991
// Project: Rigi V4.0
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:35 $
// $Source: /root/cvs/Rigi/rigiedit/cl_activenode.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef ACTIVENODE_H
#define ACTIVENODE_H

#ifndef RIGINODE_H
#include "cl_riginode.h"  // for RigiNodeList
#endif

class RigiWindow;
class RigiNode;

extern const int ACTIVE;
extern const int NORMAL;

class ActiveNode
{
private:

    int state;          // The state of the node (active or not)
    RigiNodeList nl;    // The list of rigi nodes associated with this node

public:

    ActiveNode(int);
    ActiveNode();
    ~ActiveNode();

    // Access functions for the class.

    void      SetState(int s)		{ state = s; }
    int       GetState()		{ return state; }

    // Iterators and list manipulation functions for the class.

    RigiNode* First()			{ return nl.First(); }
    RigiNode* Next()			{ return nl.Next(); }
    void      Insert(RigiNode* np)	{ nl.Insert(np); }
    RigiNode* Remove(RigiNode* np)	{ return nl.Remove(np); }
    int	      GetNoItems()		{ return nl.GetNoItems(); }
    RigiNode* FindRigiNode(RigiWindow* win);
};

#endif

