// $Author: jmcdanie $
// $Date: 1996-03-23 18:03:36 $
// $Source: /root/cvs/Rigi/rigiedit/cl_arcflags.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------


// Class for a set of arcs. Uses the BitSet class for its base
// implementation. The only real functionality that it overrides
// is the default constructor with no parameters. It creates a
// new BitSet with a size equal to the number of arcs in the
// current domain.

#ifndef ARCFLAGS_H
#include "cl_arcflags.h"
#endif
#ifndef FLAG_H
#include "cl_flag.h"
#endif
#ifndef DOMAIN_H
#include "cl_domain.h"
#endif
#ifndef RIGIINIT_H
#include "rigi_init.h"
#endif

ArcFlags::ArcFlags() : BitSet() {
    // Check to see if the domain has been created. If not 
    // just use the default bit set size.

    RigiDomain* domain = RinitGetDomain();
    if (domain) SetSize( domain->NumArcTypes() );
}


