#ifndef BCKSTORE_H
#define BCKSTORE_H

#ifndef _XLIB_H_
#include <X11/Xlib.h>
#endif

#ifndef _CCHEADER_H
#include "CCheader.h"
#endif

class BckStore {

private:
    int canw;
    int canh;
    int depth;
    Display *dpy;
    Drawable drawable;
    void *clientData;
    Pixmap pixmap;

public:
    BckStore(Display *display, Drawable d,
            int w, int h, int pixdepth, void *cdata);
    ~BckStore();
    Pixmap Map();
    void Unmap();
    Pixmap GetPixmap() const;
    RigiBool IsMapped() const;
    void *GetClientData() const;
    int NumFreeBackStore() const;

};
#endif
