//
// Stuff to keep track of list of duplicate grasids for editing functions
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:19 $
// $Source: /root/cvs/Rigi/rigiedit/cl_duplist.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: cl_duplist.C,v 1.8 1996-03-21 02:39:19 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef DUPLIST_H
#include "cl_duplist.h"
#endif
#ifndef CSTUFF_H
#include "cstuff.h"
#endif
#ifndef RIGIERR_H
#include "rigierr.h"
#endif

static int ndup=0;

DupList::DupList( int n )
{
    ndup++;
    size = n ;
    num = 0 ;
    list = (DupPair*)calloc( (unsigned)n,sizeof( DupPair ) );
    if ( list == NULL )
                Mess("DupList::DupList - Could not alloc %d DupPairs", n );
        memset( (char*)list,0,n*sizeof(DupPair) );
}

DupList::~DupList()
{
    ndup--;
    (void) free( (char*)list ) ;
    size = 0 ;
    num = 0 ;
}

int GetNoDupList() { return ndup; }

void DupList::Append( GraphNode* newnode, GraphNode* oldnode, int oldid )
{
    if ( num >= size )
    {
                mayday("Error: DupList is full") ;
        return;
    }
    list[num].oldnode = oldnode ;
    list[num].newnode = newnode ;
    list[num].oldid = oldid ;
    num++ ;
}

GraphNode* DupList::FindOldNode( int id )
{
int i ;
for( i=0 ; i<size ; i++ )
    if ( id == list[i].oldid ) return list[i].oldnode ;
return NULL ;
}

GraphNode* DupList::FindNewNode( int id )
{
int i ;
for( i=0 ; i<size ; i++ )
    if ( id == list[i].oldid ) return list[i].newnode ;
return NULL ;
}

DupPair* DupList::GetPair( int n )
{
if ( n >= size || n < 0 )
{
                mayday("Illegal pair index in GetPair, n = %d",n ) ;
    return NULL ;
}
return &(list[n]) ;
}

