//
// cl_duplist.h - A class to keep track of lists of pairs of related Nodes.
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:36 $
// $Source: /root/cvs/Rigi/rigiedit/cl_duplist.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef DUPLIST_H
#define DUPLIST_H

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif

// Object that represents a pair of nodes, one the original, the other
// a duplicate of the old node.

struct duppair
{
GraphNode* newnode ;
GraphNode* oldnode ;
int   oldid ;
} ;
typedef struct duppair DupPair ;

// List of DupPair Objects

class DupList
{
private:
    DupPair* list;
    int      size;
    int      num;

public:
    DupList(int n);
    ~DupList() ;

    // Append a pair of nodes to the list

    void     Append( GraphNode* newnode, GraphNode* oldnode, int oldid ) ;

    // Search access functions that return the DupPair or the old and new
    // nodes, given a node identifier.

    GraphNode*    FindOldNode(int);
    GraphNode*    FindNewNode(int);
    DupPair* GetPair(int);

    // List access functions.

    void     Empty()  { num = 0 ; }
    int      Size()   { return size ; }
    int      Number() { return num ; }
} ;


#endif

