//
//

// $Author: jmcdanie $
// $Date: 1996-05-24 00:35:09 $
// $Source: /root/cvs/Rigi/rigiedit/cl_graphdef.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef GRAPHDEF_H
#define GRAPHDEF_H

#define ROOT "Root"
// Definitions that may be used by other modules, but do not require the
// definitions of the graph classes themselves.

// Normalized screen definitions. All screen definitions for a node must be
// normalized so that they can be represented by any windowing system.

typedef float NDC_Coord;
typedef struct { NDC_Coord x,y,z; } NDC_Point;
typedef struct { NDC_Coord x,y; }   NDC_Point2d;
extern const NDC_Coord NDC_IllegalPos;

// Screen definitions that are actually used for display.

typedef int Coordinate;
typedef struct { Coordinate x,y,z; }  Point;
typedef struct { Coordinate x,y; }    Point2d;
extern const Coordinate IllegalPos;
extern const Point      IllegalPoint;

// Type definitions for Nodes

typedef int    NodeId;
typedef char*  NodeLabel;
typedef int    NodeType;

// Type definitions for Arcs

typedef int    ArcId;
typedef int    ArcType;
typedef char*  ArcLabel;
typedef enum { ARC_DIR_UNKNOWN = -1, ARC_IN, ARC_OUT, ARC_INOUT, ARC_INOUT_IN } ArcDirection;

// Class defintions so we can use pointers to Nodes and Arcs etc. without
// having to import the class definition.

class GraphNode;
class GraphArc;
class NodeList;
class ArcList;

#endif

