// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:38 $
// $Source: /root/cvs/Rigi/rigiedit/cl_graphnameset.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef GRAPHNAMESET_H
#define GRAPHNAMESET_H

#ifndef AVLSET_H
#include "cl_avlset.h"
#endif

#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif

class NodeNameSet : private AvlSet
{
        static void print( GraphNode* n )
            { printf("%-7d %s",n->GetId(),n->GetLabel()); }
        static int cmp( char*s, GraphNode*n )
            { return strcmp(s,n->GetLabel()); }

    public:

        NodeNameSet():AvlSet(1) {}
        ~NodeNameSet() {}

        int	Size()  { return AvlSet::Size(); }
        int	Empty() { return AvlSet::Empty(); }

        GraphNode* Insert( GraphNode*n )
            { return (GraphNode*)
                StoreInfo( (void*)n->GetLabel(), (Info*)n, (AvlFunc)cmp ); }

        GraphNode* Remove( GraphNode*n )
            { return (GraphNode*)
                RemoveInfo( (void*)n->GetLabel(), (Info*)n, (AvlFunc)cmp ); }

        GraphNode* Find( char*s )
            { return (GraphNode*)FindInfo( (void*)s, (AvlFunc)cmp); }

        GraphNode *First(AvlPos*&P){ return (GraphNode*)AvlSet::First(P);}
        GraphNode *Next(AvlPos*&P) { return (GraphNode*)AvlSet::Next(P); }

        GraphNode *First( AvlPos*&P, char*s )
            { return (GraphNode*)AvlSet::First(P,(void*)s,(AvlFunc)cmp);}

        void	Print()	{ AvlSet::Print( (void(*)(void*))print ); }
};

#endif

