#ifndef DEBUGTYPEH
#define DEBUGTYPEH
#include <stream.h>

/*===========	Debugging variables and defines. 	================*/

#ifdef FDEBUG
static int ccdebug_debug_value = 0;
#define VarDebug(a,b,c) if(ccdebug_debug_value) \
                        cerr << a; b->printout(0); cerr << " [c]" << endl
#define MsgDebug(a,b) if(ccdebug_debug_value) cerr << a << " [b]" << endl
#define ValueDebug(a,b,c) if(ccdebug_debug_value) \
 			  cerr  << a << b << " [c]" << endl
#define ListDebug(a)  if(ccdebug_debug_value) cerr << a
#define DebugOn()  ccdebug_debug_value++;
#define DebugOff() ccdebug_debug_value--;

#else
#define NoDebug(a) a
#define VarDebug(a,b,c) /* nothing */
#define MsgDebug(a,b) /* nothing */
#define ValueDebug(a,b,c) /* nothing */
#define ListDebug(a) /* nothing */
#define DebugOn() /* nothing */
#define DebugOff() /* nothing */
#endif 

/* ======================================================================  */
	
#endif



