//
// $Author: jmartin $ // $Date: 1999-06-11 13:41:08 $
// $Source: /root/cvs/Rigi/rigiedit/menus.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef MENUS_H
#define MENUS_H

// RCL1
#ifndef SELECTOPS_H
#include "selectops.h"
#endif
#ifndef SCALEOPS_H
#include "scaleops.h"
#endif
#ifndef MOVEOPS_H
#include "moveops.h"
#endif
#ifndef OPENPANELOPS_H
#include "open_panelops.h"
#endif
// Note: there is a close_panelops.h also, not used from here

#ifndef FILEOPS_H
#include "fileops.h"
#endif
#ifndef STATISTICSOPS_H
#include "statisticsops.h"
#endif
#ifndef EDITOPS_H
#include "editops.h"
#endif
#ifndef OPERATIONOPS_H
#include "operationops.h"
#endif
#ifndef VIEWOPS_H
#include "viewops.h"
#endif
#ifndef NODEOPS_H
#include "nodeops.h"
#endif
#ifndef ARCOPS_H
#include "arcops.h"
#endif

//////////////////////////////////////////
// Number of items in each of the menus //
//////////////////////////////////////////

// Arc and Node Menus

const int NUM_ARCMENU_ITEMS	= 2;
const int NUM_NODEMENU_ITEMS	= 6;

// Background Menu

const int NUM_SELECTION_ITEMS	= 13;
const int NUM_MOVE_ITEMS	= 5;
const int NUM_SCALE_ITEMS	= 4;
const int NUM_BGMENU_ITEMS	= 3;

// Menubar

const int NUM_VIEW_ITEMS	= 5;
const int NUM_FILE_ITEMS	= 9;
const int NUM_EDIT_ITEMS	= 11;
const int NUM_OPERATIONS_ITEMS	= 10;
const int NUM_STATISTICS_ITEMS	= 4;
const int NUM_OPTIONS_ITEMS	= 5;

// Arc menu stuff

MenuItem arcmenu_items[] = {

    { "Exact Interface", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())arcmenu_notify_proc,
        (void(*)())arcmenu_armnotify_proc,
        (void(*)())arcmenu_disarmnotify_proc,
        (XtPointer)ARCEINTERFACE,
        (XtPointer)"Display the Exact Interface between two subsystems",
        (MenuItem *)NULL, 0 },

    { "Attributes", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())arcmenu_notify_proc,
        (void(*)())arcmenu_armnotify_proc,
        (void(*)())arcmenu_disarmnotify_proc,
        (XtPointer)ARCATTRIBUTES,
        (XtPointer)"Display/edit attributes",
        (MenuItem *)NULL, 0 },

    NULL,
};

// Node menu stuff

MenuItem nodemenu_items[] = {

    { "Edit", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())nodemenu_notify_proc,
        (void(*)())nodemenu_armnotify_proc,
        (void(*)())nodemenu_disarmnotify_proc,
        (XtPointer)OPENEDITOR,
        (XtPointer)"Open an editor for contents of this node",
        (MenuItem *)NULL ,0},

    { "Rename", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())nodemenu_notify_proc,
        (void(*)())nodemenu_armnotify_proc,
        (void(*)())nodemenu_disarmnotify_proc,
        (XtPointer)RENAME,
        (XtPointer)"Rename this node",
        (MenuItem *)NULL ,0},

    { "Set Type", &xmCascadeButtonGadgetClass, 'N',  NULL, NULL,
        NULL, NULL, NULL, NULL, NULL, (MenuItem *)NULL,0},

    { "Expand", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())nodemenu_armnotify_proc,
        (void(*)())nodemenu_disarmnotify_proc,
        (XtPointer)EXPAND,
        (XtPointer)"Replace node with its contents",
        (MenuItem *)NULL ,0},

    { "Overview", &xmPushButtonGadgetClass, NULL,  NULL, NULL,
        (void(*)())nodemenu_notify_proc,
        (void(*)())nodemenu_armnotify_proc,
        (void(*)())nodemenu_disarmnotify_proc,
        (XtPointer)OVERVIEW,
        (XtPointer)"Open a window containing the rooted subtree",
        (MenuItem *)NULL ,0},

    { "Attributes", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())nodemenu_notify_proc,
        (void(*)())nodemenu_armnotify_proc,
        (void(*)())nodemenu_disarmnotify_proc,
        (XtPointer)NODEATTRIBUTES,
        (XtPointer)"Display/edit attributes",
        (MenuItem *)NULL, 0 },

    NULL
};

// Background Menu stuff

// RCL1: Change the activate notify for the selection items
// MJW 940126: use a new disarm notify

MenuItem selection_items[] = {

    { "Select All", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>S", "Ctrl+S",
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
            (XtPointer)SELECTALL,
        (XtPointer)"Select (and highlight) all nodes in this window",
        (MenuItem *)NULL,0 },

    { "Invert Selections", &xmPushButtonGadgetClass, NULL,
        NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
            (XtPointer)SELECTINVERT,
        (XtPointer)"Select all non-selected nodes",
        (MenuItem *)NULL,0 },

    { "Outgoing Neighbours", &xmPushButtonGadgetClass, NULL,
        NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)SELECTDST,
        (XtPointer)"Select nodes connected by outgoing arcs",
        (MenuItem *)NULL,0 },

    { "Incoming Neighbours", &xmPushButtonGadgetClass, NULL,
        NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)SELECTSRC,
        (XtPointer)"Select nodes connected by incoming arcs",
        (MenuItem *)NULL,0 },

    { "Select Forward Tree", &xmPushButtonGadgetClass, NULL,
        NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)SELECTTREE,
        (XtPointer)"Select nodes reachable via outgoing arcs",
        (MenuItem *)NULL,0 },

    { "Select Reverse Tree", &xmPushButtonGadgetClass, NULL,
        NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)SELECTRTREE,
        (XtPointer)"Selects nodes reachable via incoming arcs",
        (MenuItem *)NULL,0 },

    { "Strong Connected", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)STRONGCONNECT,
        (XtPointer)"Select nodes strongly connected to any other nodes",

        (MenuItem *)NULL,0 },
    { "Strong Component", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)STRONGCOMPONENT,
        (XtPointer)"Select nodes strongly connected to selected nodes",
        (MenuItem *)NULL,0},

    { "Weak Connected", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)WEAKCONNECT,
        (XtPointer)"Selects nodes weakly connected to any other nodes",
        (MenuItem *)NULL,0 },

    { "All Common Clients/Suppliers", &xmPushButtonGadgetClass, NULL,NULL,NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)ALLCOMMONCS,
        (XtPointer)"Select nodes according to common clients and suppliers",
        (MenuItem *)NULL,0 },

    { "Common Clients", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)COMMONCLIENT,
        (XtPointer)"Selects nodes having at least as many outgoing arcs",
        (MenuItem *)NULL,0 },

    { "Common Suppliers", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)COMMONSUPPLIER,
            (XtPointer)"Select nodes having at least as many incoming arcs",
        (MenuItem *)NULL,0 },

    { "Direct Recursive Dependencies", &xmPushButtonGadgetClass,NULL,NULL,NULL,
        (void(*)())selection_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())selmenu_disarmnotify_proc,
        (XtPointer)SELECTREC,
        (XtPointer)"Select nodes having direct recursive dependencies",
        (MenuItem *)NULL,0 },

    NULL,
};

MenuItem move_items[] = {

    { "Group Grid", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>G", "Ctrl+G",
        (void(*)())move_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)GROUPGRID,
        (XtPointer)"Place selected nodes in a grid at cursor position",
        (MenuItem *)NULL,0 },	

    { "Group Horizontally", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>H", "Ctrl+H",
        (void(*)())move_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)GROUPHORIZ,
        (XtPointer)"Place selected nodes horizontally at cursor position",
        (MenuItem *)NULL,0 },

    { "Group Vertically", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>V", "Ctrl+V",
        (void(*)())move_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)GROUPVERT,
        (XtPointer)"Place selected nodes vertically at cursor position",
        (MenuItem *)NULL,0 },	

    { "Group Diagonally", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>D", "Ctrl+D",
        (void(*)())move_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)GROUPDIAG,
        (XtPointer)"Place selected nodes diagonally",
        (MenuItem *)NULL,0 },	

    { "Move Selection", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>M", "Ctrl+M",
        (void(*)())move_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)GROUPMOVE,
        (XtPointer)"Move selected nodes to the cursor position",
        (MenuItem *)NULL,0 },	

    NULL,
};

MenuItem scale_items[] = {

    { "Scale to Window", &xmPushButtonGadgetClass, NULL,
        "Ctrl<Key>W", "Ctrl+W",
        (void(*)())scale_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)SCALEWIN,
        (XtPointer)"Adjust window size to fit all nodes",
        (MenuItem *)NULL,0 },

    { "Scale Selections", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())scale_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)SCALEBOX,
        (XtPointer)"Adjust window size to fit selected nodes",
        (MenuItem *)NULL,0 },

    { "No Scaling", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())scale_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)SCALE10,
        (XtPointer)"make node size return to default size",
        (MenuItem *)NULL,0 },

    { "Scale By Factor", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())scale_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)SCALEFACTOR,
        (XtPointer)"Adjust node size by the scale factor",
        (MenuItem *)NULL,0 },

    NULL,
};

MenuItem bgmenu_items[] = {

    { "Selection", &xmCascadeButtonGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL, selection_items, NUM_SELECTION_ITEMS},

    { "Move", &xmCascadeButtonGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL, move_items, NUM_MOVE_ITEMS},

    { "Scale", &xmCascadeButtonGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL, scale_items, NUM_SCALE_ITEMS},
        NULL,
};

// Menubar stuff

MenuItem view_items[] = {

    { "Load Global View", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_LOADVIEWPANEL,
        (XtPointer)"Display list of available global views",
        (MenuItem *)NULL,0},

    { "Save Global View", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_SAVEVIEWPANEL,
        (XtPointer)"Save current state of the windows as a global view",
        (MenuItem *)NULL,0},

    { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL,
        (MenuItem *)NULL,0 },

    { "Load Local View", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_LOADLVIEWPANEL,
        (XtPointer)"Display list of available local views",
        (MenuItem *)NULL,0},

    { "Save Local View", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_SAVELVIEWPANEL,
        (XtPointer)"Save current state of the windows as a local view",
        (MenuItem *)NULL,0},

    NULL,
};

MenuItem file_items[] = {

    { "Refresh", &xmPushButtonGadgetClass, 'R',
        "Ctrl<Key>R", "Ctrl+R",
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)REFRESH,
        (XtPointer)"Refresh the display of this window",
        (MenuItem *)NULL,0},

    { "Update", &xmPushButtonGadgetClass, 'U',  NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)UPDATE,
        (XtPointer)"Update window so that it is consistent with its graph",
        (MenuItem *)NULL,0 },

    { "Load", &xmPushButtonGadgetClass, 'L', NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)LOAD,
        (XtPointer)"Load from the database",
        (MenuItem *)NULL,0},

    { "Save", &xmPushButtonGadgetClass, 'S', NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)SAVE,
        (XtPointer)"Save the latest changes to the database",
        (MenuItem *)NULL,0},

    { "Reset", &xmPushButtonGadgetClass, 'R', NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)RESET,
        (XtPointer)"Empty the graph and close all windows",
        (MenuItem *)NULL,0},

    { "Close This Window", &xmPushButtonGadgetClass, 'C', NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)DONE,
        (XtPointer)"Close window (Note: cannot close the root window)",
        (MenuItem *)NULL,0},

    { "Close All Windows", &xmPushButtonGadgetClass, 'A',  NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)CLOSEALL,
        (XtPointer)"Close all windows except the root window",
        (MenuItem *)NULL,0},

    { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL,
        (MenuItem *)NULL,0 },

    { "Quit Rigi", &xmPushButtonGadgetClass, 'Q',
        "Ctrl<Key>Q", "Ctrl+Q",
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)QUIT,
        (XtPointer)"Exit the Rigi editor (without saving changes)",
        (MenuItem *)NULL,0 },

    NULL,
};

// Note: I need to do this because of the reading in of nodes
// This is not very elegant having these two types
// of declarations mixed here. I will change it later on so
// that the making of all menus will be read in from a file (hopefully!).

MenuItem edit_items[] = {

    { "Cut", &xmPushButtonGadgetClass, 'C',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)CUT,
        (XtPointer)"Remove selected nodes from the database",
        (MenuItem *)NULL,0},

    { "Copy", &xmPushButtonGadgetClass, 'y',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)COPY,
        (XtPointer)"Copy selected nodes to the database",
        (MenuItem *)NULL,0},

    { "Paste", &xmPushButtonGadgetClass, 'P',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)PASTE,
        (XtPointer)"Paste previously copied or deleted nodes to database",
        (MenuItem *)NULL,0},

    { "Clear Clipboard", &xmPushButtonGadgetClass, 'c',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)CLEAR,
        (XtPointer)"Clear the deleted or copied nodes from the clip board",
        (MenuItem *)NULL,0},

    { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL,
        (MenuItem *)NULL,0 },

    { "Collapse", &xmPushButtonGadgetClass, 'l',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)COLLAPSE,
        (XtPointer)"Replace selected nodes with a new subsystem",
        (MenuItem *)NULL,0},

    { "Expand", &xmPushButtonGadgetClass, 'E',  NULL, NULL,
        (void(*)())edit_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)EXPAND,
        (XtPointer)"Replace selected node with its children",
        (MenuItem *)NULL,0},

    { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL,
        (MenuItem *)NULL,0 },

    { "Show Clipboard", &xmPushButtonGadgetClass, 'S',  NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)SHOWCLIP,
        (XtPointer)"Show Clipboard (for copying/pasting/cutting nodes)",
        (MenuItem *)NULL,0},

    { "Text Editor", &xmPushButtonGadgetClass, 'T',  NULL, NULL,
        (void(*)())file_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)TEXTEDIT,
        (XtPointer)"Open a Text Editor",
        (MenuItem *)NULL,0},

        // Note this label is used in menu_util.C, if changed here it should
        // be changed there also.  Later I want to restructure menus anyway.

    { "Node Creations", &xmCascadeButtonGadgetClass, 'N',  NULL, NULL,
        NULL,
        (void(*)())menubar_armnotify_proc,
        NULL,
        NULL,
        NULL,
        (MenuItem *)NULL,0},
        NULL,
};

MenuItem operations_items[] = {

    { "Open", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPENNODES,
        (XtPointer)"Open one or more nodes",
        (MenuItem *)NULL,0 },

    { "Open Parent", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPENPARENT,
        (XtPointer)"Open window of parent node",
        (MenuItem *)NULL,0 },

    { "Project Subsystem", &xmPushButtonGadgetClass, 'P',  NULL, NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)PROJECTSYS,
        (XtPointer)"Project selected nodes and dependencies",
        (MenuItem *)NULL,0 },

        // HYPER
    { "Project To Text Level", &xmPushButtonGadgetClass, 'P',  NULL, NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)PROJECTTEXT,
        (XtPointer)"Project selected nodes to text level",
        (MenuItem *)NULL,0 },

    { "Arc Hierarchy", &xmPushButtonGadgetClass, 'A',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_HIERARCHYPANEL,
        (XtPointer)"Display structure of subgraph rooted at selected node",
        (MenuItem *)NULL,0 },

    { "Arc Thresholds", &xmPushButtonGadgetClass, 'T', NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_THRESHOLDSPANEL,
        (XtPointer)"Identify central and fringe components in the graph",
        (MenuItem *)NULL,0 },

    { "Search", &xmPushButtonGadgetClass, NULL, NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())bgmenu_armnotify_proc,
        (void(*)())bgmenu_disarmnotify_proc,
        (XtPointer)OPEN_GREPPANEL,
        (XtPointer)"Select node sets based on string pattern matching",
        (MenuItem *)NULL,0 },

    { "", &xmSeparatorGadgetClass, NULL, NULL, NULL,
        NULL, NULL, NULL, NULL, NULL,
        (MenuItem *)NULL,0 },

    { "Forward Dependency Tree", &xmPushButtonGadgetClass, 'F', NULL,NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)MAKETREE,
        (XtPointer)"Arrange a tree of nodes the selected node depends upon",
        (MenuItem *)NULL,0 },

    { "Reverse Dependency Tree", &xmPushButtonGadgetClass, 'R', NULL, NULL,
        (void(*)())operation_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)MAKERTREE,
        (XtPointer)"Arrange a tree of nodes depending on selected node",
        (MenuItem *)NULL,0 },
        NULL,
};

MenuItem statistics_items[] = {

    { "Exact Interface", &xmPushButtonGadgetClass, 'E',  NULL, NULL,
        (void(*)())statistics_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)EINTERFACE,
        (XtPointer)"Provide a report about nodes and their dependencies",
        (MenuItem *)NULL,0 },

    { "Typed Exact Interface", &xmPushButtonGadgetClass, 'T',  NULL, NULL,
        (void(*)())statistics_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)EINTERFACETYPED,
        (XtPointer)"Provide a typed report about nodes and dependencies",
        (MenuItem *)NULL,0},

    { "Graph Quality", &xmPushButtonGadgetClass, 'G',  NULL, NULL,
        (void(*)())statistics_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)GQUALITY,
        (XtPointer)"Produce a report on subsystem decomposition quality",
        (MenuItem *)NULL,0 },

    { "Window Statistics", &xmPushButtonGadgetClass, 'W',  NULL, NULL,
        (void(*)())statistics_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)WINSTATS,
        (XtPointer)"Produce a listing for number of (filtered) nodes/arcs",
        (MenuItem *)NULL,0 },
        NULL,
};

MenuItem options_items[] = {

    { "Rigi Defaults...", &xmPushButtonGadgetClass, 'D',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_CONTROLPANEL,
        (XtPointer)"set parameters for all Rigi Windows",
        (MenuItem *)NULL,0 },

    { "Window Filters...", &xmPushButtonGadgetClass, 'F',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_FILTERPANEL,
        (XtPointer)"apply filters to this window only",
        (MenuItem *)NULL,0 },

    { "Arc Colors...", &xmPushButtonGadgetClass, 'A',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_ARCCOLORPANEL,
        (XtPointer)"Panel used to set arc colors for all Rigi windows",
        (MenuItem *)NULL,0 },

    { "Node Colors...", &xmPushButtonGadgetClass, 'N',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_NODECOLORPANEL,
        (XtPointer)"Panel used to set node colors for all Rigi windows",
        (MenuItem *)NULL,0 },

    { "Node Legend...", &xmPushButtonGadgetClass, 'L',  NULL, NULL,
        (void(*)())panel_notify_proc,
        (void(*)())menubar_armnotify_proc,
        (void(*)())menubar_disarmnotify_proc,
        (XtPointer)OPEN_NODELEGENDPANEL,
        (XtPointer)"Panel used to map node types to icons",
        (MenuItem *)NULL,0 },

    NULL,
};

#endif
