/* (C) Universitaet Passau 1986-1991 */
/*********************************************************************************/
/*                                                                               */
/*                            M  A  I  N  .  C                                   */
/*                                                                               */
/*********************************************************************************/


#include "def.h"

Sugiyama_settings sugiyama_settings;

#include <slist.h>
#include <algorithms.h>


/* Global int maxlevel = 0; */
Global int maxlevel = 1;	/* Set to 1 to correct possible but in */
				/* starting, MH 12/10/91               */
Global int nodes_of_level[SIZE];


Global bool	sugiyama (g, horizontal_distance, vertical_distance)
Sgraph		g;
int		horizontal_distance,	/* horizontaler Abstand zwischen je zwei Knoten	*/ 
		vertical_distance;	/* vertikaler Abstand zwischen je zwei Knoten	*/ 

{
	bool c;
	
	maxlevel = 2; /* Just a little workaround ... MH 12/10/91 */
	
	if (g != empty_graph)
	{
		c = find_cycles(g);
		if (c)
		{		
			fprintf(stderr, "There are cycles in the graph\n");
			fprintf(stderr, "No hierarchical layout possible\n");
			exit(-1);
			return FALSE;
		}
		else
		{
			int	i;
			int	max_nodes_of_level;

			prepare(g);
			make_hierarchy(g);

			if (maxlevel > SIZE) {
		 		fprintf(stderr, "Graph is too large - %d levels, %d permitted\n",
			 		maxlevel, SIZE);
				exit(-1);
				return FALSE;
			}

			add_dummies(g);
			init_positions(g);

			max_nodes_of_level = 0;
			for (i=0; i<maxlevel; i++) {
				max_nodes_of_level = maximum (nodes_of_level[i], max_nodes_of_level);
			}
			if (max_nodes_of_level > SIZE) {
				fprintf( stderr, "Graph is too wide - %d nodes, %d permitted\n",
					max_nodes_of_level, SIZE);
				exit(-1);
				return FALSE;
			}

			reduce_crossings(g);
			improve_positions(g);
			set_horizontal_positions(g, horizontal_distance);
			set_vertical_positions(g, vertical_distance);
			remove_dummies(g);
			
			return TRUE;
		}
	} else {
		return	FALSE;
	}
}

/************************************************************************/
/*									*/
/*			    sugiyama layout				*/
/*									*/
/************************************************************************/


char	*sugiyama_layout (sgraph, horizontal_distance, vertical_distance)
Sgraph	sgraph;
int     horizontal_distance;
int     vertical_distance;
{
	int	successful;

	sugiyama_settings.vertical_distance =vertical_distance ;
	sugiyama_settings.horizontal_distance =horizontal_distance ;

	if (sgraph == empty_sgraph || sgraph->nodes == empty_node) {
	
		
	} else if (!sgraph->directed) {
	
		fprintf( stderr, "Graph is not directed\n");
		exit(-1);
		
	} else {
		
		Snode	n;
		Sedge	e;

		successful = sugiyama (sgraph, horizontal_distance, vertical_distance);

		if (successful) {
			
			int		*pos, i;
/*
			Edgeline	el;
*/
			int		successful;

			for_all_nodes (sgraph, n) {
	
				for_sourcelist (n, e) {
		
#if 0
					el = (Edgeline)NULL;
					pos = (attr_data_of_type(e,int *));
					for (i=0; pos[i] != 0; i += 2)
						el = add_to_edgeline (el, pos[i], pos[i+1]);
					edge_set (graphed_edge(e), ONLY_SET, EDGE_LINE,
						el->suc, 0);
#endif
					myfree(attr_data(e));
			
	   			} end_for_sourcelist (n, e);
			
			} end_for_all_nodes (sgraph, n);

		} else {
/*
			test_find_cycle_in_directed_graph (graphed_graph(sgraph));
*/
		}
	}
}

/*********** E n d e   S U G I . C ************************************************/


