/*
 * rigiarcs.h: Definition of Rigi's arc types.	[SRT 28Jul93]
 *
 * Note: This file is currently shared by both C and C++ source, so it
 *       must be C-compatible for now.
*/

/* $Author: kenw $ */
/* $Date: 1995-06-17 05:15:56 $ */
/* $Source: /root/cvs/Rigi/rigiedit/rigiarcs.h,v $ */
/* $Locker:  $ */
/* $State: Exp $ */

/*------------------------------------------------------------------------*/

#ifndef RIGIARCS_H
#define RIGIARCS_H

/* Types of Arcs */

#define LEVEL_ARC  0 
#define NORMAL_ARC 1
#define HYPER_ARC  2

/**************** Definitions for 3GL programming languages ****/

/* Sub Types of Normal Arcs */

#define CALL_ARC 	0
#define DATA_ARC 	1
#define STRUCTURE_ARC 	2
#define SYNTACTIC_ARC	3
#define BLOCK_ARC	4
#define INCLUDE_ARC	5
#define COMPOSITE_ARC   6
#define REFRACTIVE_ARC  7

#define SUBTYPESTRINGS	{"CALL","DATA","STRUCTURE","SYNTACTIC",\
		"BLOCK","INCLUDE","COMPOSITE","REFRACTIVE"}

/* Sub Types of Hyper Arcs */

#define INSERT_ARC      0
#define SEARCH_ARC      1
#define SOURCE_ARC      2
#define LIBRARY_ARC     3

/* Types of Nodes */

#define ILLEGAL_NODE	65535
#define COLLAPSE_NODE	0
#define SYS_NODE	1
#define REL_NODE	2
#define PRO_NODE	3
#define MODULE_NODE	4
#define REV_NODE	5
#define DEF_NODE	6
#define IMP_NODE	7
#define GEN_NODE	8
#define ALT_NODE	9
#define DOC_NODE	10
#define DAT_NODE	11
#define PIC_NODE	12
#define ACC_NODE        13
#define SYNTACTIC_NODE	14
#define EXECUTABLE_NODE	15
#define DIRECTORY_NODE	16
#define FILE_NODE 	17
#define SCOPE_NODE 	18
#define FUNCTION_NODE 	19
#define BLOCK_NODE	20
#define LINK_NODE	21
#define SUBSYSTEM_NODE	22
#define DATATYPE_NODE	23

#define NODESTRINGS	{"COLLAPSE","SYS",REL","PRO","MODULE","REV",\
		"DEF","IMP","GEN","ALT","DOC",DAT","PIC","ACC",\
		"SYNTACTIC","EXECUTABLE","DIRECTORY","FILE","SCOPE",\
		"FUNCTION","BLOCK","LINK","SUBSYSTEM","DATATYPE"}

/**************** Definitions for hypertext *******************/

/* Arc types */
/* Subtypes of NORMAL arcs */
#define SEQ_ARC 			CALL_ARC	/* Sequential  0 */
#define REF_ARC 			STRUCTURE_ARC	/* Referential 2 */
#define STR_ARC				SYNTACTIC_ARC	/* Structural  3 */
#define IMPLICIT_REF_SIBLING_ARC 	BLOCK_ARC	/* Not used yet */

/* Node types */
#define DOCUMENT_NODE			SUBSYSTEM_NODE
#define PART_NODE			PRO_NODE	/* Not used yet */
#define CHAPTER_NODE			DIRECTORY_NODE
#define SECTION_NODE			FILE_NODE
#define SUBSECTION_NODE 		FUNCTION_NODE
#define SUBSUBSECTION_NODE 		GEN_NODE	/* Not used yet */
#define PARAGRAPH_NODE			DATATYPE_NODE
#define ITEM_NODE			ACC_NODE	/* Not used yet */

#endif

/*-------------------------RCS--------------------------------------------*/
/*
 * 
 * $Log: not supported by cvs2svn $
 * Revision 1.1  1995/06/17  01:30:15  kenw
 * Initial revision
 *
 *   Revision 1.3  1994/01/12  17:51:20  mwhitney
 *   Scott changed to C and C++ compatible commenting
 *   Mike added SUBTYPESTRINGS and NODETYPESTRINGS
 *
 *   Revision 1.2  1993/08/05  17:35:57  stilley
 *   Change of arc types for lreverse/rigiedit sync.
 *
 *   Revision 1.1  1993/07/28  16:13:20  stilley
 *   Initial revision
 *
*/
