//
// rigisignal.C: Signal handling routines.	[SRT 19Sep93]
//

// $Author: jmartin $
// $Date: 1999-06-11 14:27:25 $
// $Source: /root/cvs/Rigi/rigiedit/rigisignal.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: rigisignal.C,v 1.12 1999-06-11 14:27:25 jmartin Exp $";

//------------------------------------------------------------------------

 /********************************************************************/
 /* signal handling routines                                         */
 /********************************************************************/

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef __STDIO_H
#include <stdio.h>
#endif

#include <signal.h>

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

#include "rigisignal.h"

#if defined(sun) && !defined(__svr4__)
  static void sigtrap( int, ... );
#else
  static void sigtrap( int );
#endif

#if 0
static void sigwarn( int );
static void sigerr( int );
static char buff[512];
#endif

 /********************************************************************/
 /* catchSignal():  catch all runtime signals                        */
 /********************************************************************/
void catchSignal()
{
#ifndef __EMX__
  signal( SIGFPE,  sigtrap );
  signal( SIGILL,  sigtrap );
  signal( SIGSEGV, sigtrap );
// We ignore SIGABRT now, because we need to be able to dump core files
// for debugging purposes.  [BDC 2/3/94]
//  signal( SIGABRT, sigtrap );
  signal( SIGINT,  sigtrap );
  signal( SIGTERM, sigtrap );
#endif
#if 0
  signal( SIGUSR1 /*SIGWARN*/, sigwarn);         /* trap runtime warnings    */
  signal( SIGUSR2 /*SIGERR*/,  sigerr);          /* trap runtime fatal errors*/
#endif

  return;
}

 /********************************************************************/
 /* sigtrap():  generic signal handler/trapping routine.  Most       */
 /* signals get passed here, then acted up via the longjmp() call    */
 /* and the environment that was set up eariler in sigmask() through */
 /* a setjmp() call.                                                 */
 /********************************************************************/

#if defined(sun) && !defined(__svr4__)
  static void sigtrap( int sig, ... )
#else
  static void sigtrap( int sig )
#endif
{
  cerr << "rigiedit: error: signal ";
  switch (sig) {

	 case SIGFPE:
		cerr << "SIGFPE";
		break;

	 case SIGILL:
		cerr << "SIGILL";
		break;

	 case SIGSEGV:
		cerr << "SIGSEGV";
		break;

	 case SIGABRT:
		cerr << "SIGABRT";
		break;

	 case SIGTERM:
		cerr << "SIGTERM";
		break;

	 case SIGINT:
		cerr << "SIGINT";
		break;

	 default:
		cerr << "*unkown*";
		break;
  }
  cerr << " (" << sig << ") has occurred.\n";
  cerr << "Quit rigiedit? [y/n]: ";
  char buff[132];
  *buff = 'Y';
  scanf( "%[^\n]", buff );
  if (*buff == 'Y' || *buff == 'y') {

      // Ask if we should dump a core file
      if (*buff != '\n') (void)getchar();		// Eat '\n'
      cerr << "Dump a core file? [y/n]: ";
      *buff = 'Y';
      scanf( "%[^\n]", buff );
      if (*buff == 'Y' || *buff == 'y')
          abort();
      else
          exit( sig );
  } else {
      signal( sig, sigtrap );
      if (*buff != '\n') (void)getchar();		// Eat '\n'
      return;
  }
}

#if 0
 /********************************************************************/
 /* sigwarn():  trap the SIGWARN signal, a runtime warning           */
 /********************************************************************/
static void sigwarn( int sig )
{
  if (sig != SIGWARN) {
    sprintf( buff, "in sigwarn(), signal %d is not SIGWARN!", sig );
    Mess( buff );
//    panic( buff );
  }

  rWarn (NULL, "SIGUSR1 occurred");

  return;
}

 /********************************************************************/
 /* sigerr():  trap the SIGERR signal, a fatal error at runtime      */
 /********************************************************************/
static void sigerr( int sig )
{
  if (sig != SIGERR) {
    sprintf( buff, "in sigerr(), signal %d is not SIGERR!", sig );
    Mess( buff );
//    panic( buff );
  }

  rWarn (NULL, "SIGUSR2 occurred");

  return;
}
#endif

