// $Author: jmcdanie $
// $Date: 1996-04-30 23:11:21 $
// $Source: /root/cvs/Rigi/rigiedit/tk_colormap.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------


#ifndef TKCOLORMAP_H
#define TKCOLORMAP_H

#include "adt/object.h"

typedef struct {
    unsigned long pixel;
    unsigned short red, green, blue;
    void     *info;
} RigiColor;


class RigiColorMap : public RigiObject 
{
    private:
        RigiColor     *colors;   // dynamic array of colours
        int            ncolors;
        unsigned long *pixels;
        RigiColor      fg, bg;

        void SetColor( int, RigiColor* );

    public:
        // Constructor and Destructor for this class
        RigiColorMap();
        ~RigiColorMap();

        // Init procedures
        void InitColorMap();

        // Get procedures
        RigiColor *GetArcColor( int i );
        RigiColor *GetNodeColor( int i );
        RigiColor *GetStringColor( int i );
        int  GetColorIndex( const RigiColor& color );


        // Set procedures
        void SetArcColor( int i, RigiColor *col );
        void SetNodeColor( int i, RigiColor *col );
        void SetStringColor( int i, RigiColor *col );

        // Reset procedures
        void ResetArcColor( int i, RigiColor *col);
        void ResetNodeColor( int i, RigiColor *col);
        void ResetStringColor( int i, RigiColor *col);

        // Used for craigs hashing stuff
        RigiBool operator==(const RigiColorMap&) const;
        void operator=(const RigiColorMap&);

        // Routines that are required by a Object class and derived classes of
        // objects
        virtual RigiBool isEqual(void* a) const;
        virtual void* Duplicate() { return (NIL); } // not implemented
        virtual void* Create() { return (NIL); } // not implemented
        virtual void Delete_type(ObjectPtr) {} // not implemented
}; 

extern RigiColorMap *rigi_colormap; 

#endif

