// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:53 $
// $Source: /root/cvs/Rigi/rigiedit/tk_control.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

//------------------------------------------------------------------------

#ifndef TKCONTROLPANEL_H
#define TKCONTROLPANEL_H

#include "cl_rigistate.h"
#include "CCheader.h"
#include "adt/object.h"

// The control dialog window is a custom dialog window made just for the
// control panel. It is not flexible like the other dialog windows in that
// it always looks the same.

class ControlDialogWindow
{
private:

public:

        ControlDialogWindow();
        ~ControlDialogWindow();

        // Methods to create, destroy, and display the windows for the class
        // Initialize() creates window dependant stuff, Destroy() releases any
        // resources allocated by Initialize(). RigiDisplay() over rides the
        // same functions provided by the class DialogWindow, adding a bit of
        // extra functionality to set the panel items to the correct state.

        void	Initialize();
        void	Destroy();
        void	Display();

        // reset access functions and widgets used when loading a view

        void	SetOVDepth(int);
        void	SetProjectionDepth(int);
        void	SetHierarchyDepth(int);

        void	SetScaleFactor(int);
        void	SetScaleFunction(RigiScale);
        void	SetConstraintFunction(RigiConstraint);

        void	SetSelectionMask(int);
        void	SetGridSize(int);
        void	SetReportType(RigiReport);
        void	SetArcType(int);
        void	SetArcSet(ArcSet&);
        void	SetHighThreshold(float);
        void	SetLowThreshold(float);
        void	SetInheritFilters(RigiBool);

        // Used for craigs hashing stuff

        RigiBool operator==(const ControlDialogWindow&) const;
        void	operator=(const ControlDialogWindow&);

        // Routines required by a RigiObject class and derived classes
        virtual RigiBool isEqual(void* a) const;
        virtual void* Duplicate() { return (NIL); } // not implemented
        virtual void* Create() { return (NIL); } // not implemented
        virtual void  Delete_type(ObjectPtr) {} // not implemented
};

#endif
