// $Author: jmartin $
// $Date: 2002-11-10 22:16:58 $
// $Source: /root/cvs/Rigi/rigiedit/tk_textsw.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

const static char rcsid[] = "$Id: tk_textsw.C,v 1.9 2002-11-10 22:16:58 jmartin Exp $";

//------------------------------------------------------------------------

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#ifdef __WIN32__
#include <process.h>
#endif

#ifndef ENVIRON_H
#include "environ.h"
#endif
#ifndef DOMAIN_H
#include "cl_domain.h"
#endif
#ifndef TK_TEXTSW_H
#include "tk_textsw.h"
#endif
#ifndef DEBUGTYPEH
#include "ccdebug.h"
#endif
#ifndef RIGIERR_H
#include "rigierr.h"
#endif
#ifndef RCL_COMMANDS_H
#include "rcl_commands.h"
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif

static FILE *fp = NULL;
static RigiBool openFailed = RigiFalse;
static char fileName[MAXPATHLEN + 1];

void TextStartReport() {

    if (!openFailed && fp == NULL) {
        char *dir;
        if ((dir = EnvGet("TMPDIR")) == NULL) dir = ".";
        int pid = getpid();
        sprintf(fileName, "%s/rigi-%u-rpt.txt", dir, pid);
        if ((fp = fopen(fileName, "w")) == NULL) {
            RigiError(ERRORFLAG, "Unable to open %s", fileName);
            openFailed = RigiTrue;
        } else {
            fclose(fp);
        }
    }
    if (fp != NULL) fp = fopen(fileName, "a");
}

void TextEndReport() {
    if (fp != NULL) fclose(fp);
    fp = NULL;
    openFailed = RigiFalse;
}

int TextWriteStr( char* str ) {
    int len = strlen(str);
    if (!len) return 1;
    if (fp == NULL && len) {
        if (str[--len] == '\n') str[len] = 0;
        warn(str);
        return 1;
    }
    return (fwrite(str, strlen(str), 1, fp) == 1);
}

char *TextGetFileName() {
    return fileName;
}

