//
//

// $Author: mwhitney $
// $Date: 1995-12-15 17:53:27 $
// $Source: /root/cvs/Rigi/rigiedit/treelists.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef TREELISTS_H
#define TREELISTS_H

#ifndef GRAPHARCSET_H
#include "cl_grapharcset.h"
#endif
#ifndef HASHNODELIST_H
#include "cl_hashnodelist.h"
#endif
#ifndef GRAPHDEF_H
#include "cl_graphdef.h"       // ArcType
#endif

class GraphNode;

// Functions that are useful for tree traversal using the graph iterators
// provided in the GraphNode and GraphArc classes. The function TreeMakeLists
// can be used as an action function that is called for every node in the
// iteration process. That is, it is called for each and every node in
// the tree traversal. The function compiles 4 lists. depfrom is
// a list of all the arcs that originate within the tree, depinto is
// a list of all the arcs that terminate within the tree, children is
// a list of all the nodes that are in the subtree, and leaves is a list
// of all the children nodes in the subtree. The type of arcs that are
// processed can be set by using the function TreeSetType(), or all arcs
// (except composite and refractive arcs) can be used by calling the function
// TreeUseAllTypes(). The lists can all be initilaized by calling the
// function TreeInitLists(). If the lists are not initialized, then there
// may be extraneous nodes and arcs from previous uses of the module.

extern ArcSet depfrom,depinto ;
extern HashNodeList children;
extern HashNodeList leaves;

extern void TreeInitLists();
extern void TreeSetType( ArcType );
extern void TreeUseAllTypes();
extern void TreeMakeLists( GraphNode* );

#endif

