
// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:32 $
// $Source: /root/cvs/Rigi/rigiedit/util.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: util.C,v 1.29 1996-03-21 02:39:32 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef UTIL_H
#include "util.h"
#endif

#ifndef RIGISTATE_H
#include "cl_rigistate.h"       // Global instance of editor's state
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif

#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif
#ifndef GRAPHARC_H
#include "cl_grapharc.h"
#endif
#ifndef RIGIUTIL_H
#include "rigiutil.h"
#endif

#ifndef RIGIERR_H
#include "rigierr.h"
#endif

extern "C"
{
    int atoi( const char* );
}

GraphArc *create_arc( GraphNode *src, GraphNode *dst, int arctype )
{
    if (!src || !dst) mayday("NULL src or dst in create_arc");
    GraphArc* a = new GraphArc( src,dst, arctype );

    if ( arctype == editor->LevelArc() ) dst->SetLevel();

    src->InsertArc( a );
    dst->InsertArc( a );

    RutilCreateArc(a);
    return a;
}

GraphNode* create_node( GraphNode* parent, char* str, int type )
{
    // Create the node

    GraphNode* n = new GraphNode( str );
    n->SetType( type );

    // Create the level arc between this node and its parent. This must be done
    // before the next step (setting the node's position) because SetLevel()
    // uses the level arc to determine the node's level.

    if (parent)
    {
        create_arc( parent,n,editor->LevelArc() );
        n->SetLevel();
    }

    // Add node to hash list

    RutilCreateNode(n);
    return n;
}

GraphNode* NodeExists( int id ) { return editor->FindNode((NodeId)id); }
GraphArc* ArcExists( int id ) { return editor->FindArc((ArcId)id); }
