//
// $Author: jmcdanie $
// $Date: 1996-04-23 22:30:56 $
// $Source: /root/cvs/Rigi/rigiedit/windowgrep.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: windowgrep.C,v 1.20 1996-04-23 22:30:56 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef STREAMH
#include <stream.h>
#endif

#ifndef CHARTYPEH
#include "adt/chartype.h"
#endif
#ifndef RIGINODE_H
#include "cl_riginode.h"
#endif
#ifndef RIGIWINDOW_H
#include "cl_rigiwindow.h"
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif
#ifndef RIGIUTIL_H
#include "rigiutil.h"
#endif

#ifndef RIGISTATE_H
#include "cl_rigistate.h"       // Global instance of editor's state
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif
#ifndef RIGIERR_H
#include "rigierr.h"
#endif

// Static variable for the iterator function to compare to.

static CharType resp;

static void grepnode( GraphNode* node, RigiNode* rn )
{
    if (node->GrepNodeLabel(resp.string())) editor->SelectNode(rn);
}

int window_grep( char* str )
{
    RigiNode*  rn;
    RigiWindow* window;
    GraphNode* node;
        int recursive = 0;

    if ((window = RutilActiveWindow()) == NULL) return 0;

    // For each window node check for text string from the interface window

    int i=0; AvlPos *P;
    for ( rn = window->FirstNode(P); rn; rn = window->NextNode(P) )
    {
        node = rn->GetNode();
        if (!recursive && node->GrepNodeLabel(str))
        {
            i++; editor->SelectNode(rn);
        }
        if (recursive)
            node->TreeDFS(outLevArcs,(VarArgFunRef)(&(grepnode)),rn,NULL,NULL);
    }
        return i;
}

int window_find( char* str )
{
    RigiWindow *rw = RutilActiveWindow();
    if (rw == NULL) return 0;

    GraphNode *node = editor->FindNode( str );
    RigiNode *rn = rw->FindRigiNode( node );
    if (!rn) return 0;
    editor->SelectNode(rn);
    return 1;
}

